--- old/usr/src/cmd/ztest/ztest.c	Fri Aug  2 13:20:50 2013
+++ new/usr/src/cmd/ztest/ztest.c	Fri Aug  2 13:20:50 2013
@@ -3605,6 +3605,9 @@
 	else
 		dmu_tx_hold_write(tx, bigobj, bigoff, bigsize);
 
+	/* This accounts for setting the checksum/compression. */
+	dmu_tx_hold_bonus(tx, bigobj);
+
 	txg = ztest_tx_assign(tx, TXG_MIGHTWAIT, FTAG);
 	if (txg == 0) {
 		umem_free(packbuf, packsize);
--- old/usr/src/uts/common/fs/zfs/dmu_tx.c	Fri Aug  2 13:20:52 2013
+++ new/usr/src/uts/common/fs/zfs/dmu_tx.c	Fri Aug  2 13:20:52 2013
@@ -448,12 +448,12 @@
 		blkid = off >> dn->dn_datablkshift;
 		nblks = (len + dn->dn_datablksz - 1) >> dn->dn_datablkshift;
 
-		if (blkid >= dn->dn_maxblkid) {
+		if (blkid > dn->dn_maxblkid) {
 			rw_exit(&dn->dn_struct_rwlock);
 			return;
 		}
 		if (blkid + nblks > dn->dn_maxblkid)
-			nblks = dn->dn_maxblkid - blkid;
+			nblks = dn->dn_maxblkid - blkid + 1;
 
 	}
 	l0span = nblks;    /* save for later use to calc level > 1 overhead */
